/********************************************************
Workspace: IAR
MCU      : STM8L101K3 (HSI 2MHz)
Project  : dimmer with pb
Version  : 0
Date     : Nov, 2017
*********************************************************/
#include <iostm8l101k3.h>
#include "defines.c"
#include "bitset.c"
#include "periph_init.c"


#pragma vector = TIM3_CAPCOM_CC1IF_vector
 __interrupt void TIM3_CC()
 { 
  #define btn_pullup PC_DDR_DDR6 = 0
  #define btn_pulldn PC_DDR_DDR6 = 1
  
  static u8 dval = 0xff/4; 

  if(!TIM3_CCR1H) goto skip_t3cc;
  
  CLK_CKDIVR = 0;
  btn_pullup;  
  //timer works
  {
   TIM2_EGR  = 1;
   TIM3_EGR  = 1;
   TIM2_CR1_CEN = 0;
   TIM3_CR1_CEN = 0;
 
   u16 tmp = TIM3_CCR1H<<8;
   tmp    |= TIM3_CCR1L;  
   tmp   >>= 2;

   TIM2_ARRH = tmp>>8;
   TIM2_ARRL = (u8)tmp;
   
   tmp = (u32)tmp*dval>>8;
   TIM2_CCR1H = tmp>>8;
   TIM2_CCR1L = (u8)tmp;
   tmp-=2;
   TIM2_CCR2H = tmp>>8;
   TIM2_CCR2L = (u8)tmp;
  }
  //end of timer works
  
    //button works  
  {
   #define lp  3 
   #define lh  50
   #define lr  2   
   #define key PC_IDR_IDR6   
   
   static bool p_trg, on_off=1, dir=1;
   static enum {rls,prs,hold} btn;
   static u8 count[2]; 

   if (!key)
   {
    if(count[0]>lh) 
    {
     btn=hold;
    }
    else if(count[0]>lp)
    {
     btn=prs;
     
     count[0]++;
     count[1]=lr;
    }
    else count[0]++;
   }
   else
   {
    if(count[1])count[1]--; 
    else 
    {
     btn=rls; 
     count[0]=0;
    }
   } 
   
   btn_pulldn;   
 
   static u8 dval_tmp;
   
   if(on_off) 
   {
    TIM2_BKR_MOE = 1;
    if(dval_tmp>dval)
    {
     if(dval<0xff-2)dval+=2;
     else dval = 0xff; 
    }
    else dval_tmp = 0;
   }
   
   if(btn==rls)
   {
    if(p_trg)
    {
     p_trg=0;     
     if(!(on_off^=1))
     {
      dir=1;
      TIM2_BKR_MOE = 0;
      dval_tmp = dval;
      dval=0x0f;
     }
    }    
   }
   else if(btn==prs)
   {
    p_trg=1;
   }
   else
   {
    p_trg=0;

    static u8 cntdn;
    
    on_off=1;
    
    if(cntdn)cntdn--;
    else if(dir)
    {
     if(dval<0xff-2)dval+=2;
     else 
     {
      dir=0;
      cntdn=50;
      dval=0xff;
     }
    }
    else 
    {
     if(dval>0xff/4)dval-=2;
     else 
     {
      dir=1;
      cntdn=50;
     }
    }
   } 
  }
  //end of button works
  
  PB_ODR_ODR3^=1;
  IWDG_KR = IWDG_KEY_REFRESH;   
  TIM2_CR1_CEN   |= 1;
  TIM3_CR1_CEN   |= 1;

  CLK_CKDIVR = 3;  
  
  skip_t3cc:
  TIM3_SR1 = 0;
 }
 
#pragma vector = TIM4_UIF_vector
 __interrupt void TIM4_UPD()
 { 
  LED^=1;

  TIM4_SR1 = 0;
 }


int main()
{
 cfg.gpio();
 cfg.cpu();
 cfg.clk();
 cfg.t2();
 cfg.t3();
 cfg.t4();
 cfg.iwdg();
 
 asm("rim");
 
 endless asm("wfi");
}
